#include <windows.h>
#include "IniFile.h"
#include "w32_exptsppt.h"
#include "AddUnicode.h"

// *** Important note (Eric):
// *** as .ini files seem not to be good for sequential reading,
// *** the session control script has to be in the .txt file!
// *** Nothing was really changed here - only some default values.
// *** TimeLimit is currently unused (the values from the script
// *** are used instead), but I left the code as-is.

// default values:

#define TEXT_FILENAME TEXT("reading_script.txt")
#define FONT_NAME TEXT("Times Roman")
#define FONT_HEIGHT SCRHEIGHT/25 
#define LINE_SPACING SCRHEIGHT/14
#define TIME_LIMIT 20000L

///////////////////////////////////////
#define MAX_STRING 1024
LPCTSTR gpszDefaultIniName = TEXT("reading.ini");
LPCTSTR gpszIniSection = TEXT("TextParams");
TCHAR gpszIniFilename[MAX_STRING];

LPCTSTR gpszEntry_TextFilename = TEXT("text_filename");
LPCTSTR gpszEntry_FontName = TEXT("font_name");
LPCTSTR gpszEntry_FontHeight = TEXT("font_height");
LPCTSTR gpszEntry_LineSpacing = TEXT("line_spacing");
LPCTSTR gpszEntry_TimeLimit = TEXT("time_limit");

TEXTPARAMS gIniPara;  // holds parameters of ini file

////////////////////////////////////////////
void GetIniName()
{
	DWORD dwRet;

	dwRet = GetCurrentDirectory(MAX_STRING, gpszIniFilename);

	if (dwRet > 0 && dwRet < MAX_STRING)
	{
		lstrcat(gpszIniFilename, TEXT("\\"));
		lstrcat(gpszIniFilename, gpszDefaultIniName);
	}
	else
	{
		MessageBox(NULL, 
			TEXT("Could not get current directory. INI-file created in WINDOWS directory."), 
			TEXT("Error in GetIniName"), MB_ICONWARNING);

		lstrcpy(gpszIniFilename, gpszDefaultIniName);
	}
}

BOOL ReadInt(PLONG pl, LPCTSTR pszEntry)
{
	const UINT nErrVal = 0xFFFF;
	UINT nVal = GetPrivateProfileInt(gpszIniSection, (LPCTSTR) pszEntry, nErrVal, gpszIniFilename);
	if (nVal == nErrVal)
	{
		*pl = 0;
		return FALSE;
	}
	else 
	{
		*pl = (long) nVal;
		return TRUE;
	}
}

BOOL ReadString(TCHAR* pszString, LPCTSTR pszEntry)
{
	TCHAR pcBuf[CHAR_MAX];
	DWORD dwRet;
	dwRet = GetPrivateProfileString(gpszIniSection, (LPCTSTR) pszEntry, TEXT(""), pcBuf, CHAR_MAX, gpszIniFilename);
	lstrcpy(pszString, pcBuf);

	if (lstrlen(pszString) == 0)
		return FALSE;
	else
		return TRUE;
}

BOOL WriteString(TCHAR* pszString, LPCTSTR pszEntry)
{
	BOOL bRet = WritePrivateProfileString(gpszIniSection, (LPCTSTR) pszEntry, pszString, gpszIniFilename);
	return bRet;
}
	
BOOL WriteInt(long n, LPCTSTR pszEntry)
{
	BOOL bRet;
	TCHAR pcBuf[DIGIT_MAX];
	wsprintf(pcBuf, TEXT("%d"), n);
	bRet = WritePrivateProfileString(gpszIniSection, (LPCTSTR) pszEntry, pcBuf, gpszIniFilename);
	return bRet;
}	

BOOL ReadParams(PTEXTPARAMS pPara)
{
	BOOL bRet;

	GetIniName();

	bRet = ReadString(pPara->pszTextFilename, gpszEntry_TextFilename);
	bRet &= ReadString(pPara->pszFontName, gpszEntry_FontName);	
	bRet &= ReadInt(&pPara->lFontHeight,gpszEntry_FontHeight);
	bRet &= ReadInt(&pPara->lLineSpacing,gpszEntry_LineSpacing);
	bRet &= ReadInt(&pPara->lTimeLimit,gpszEntry_TimeLimit);

	return bRet;
}

BOOL WriteParams(PTEXTPARAMS pPara)
{
	BOOL bRet;

	GetIniName();

	bRet = WriteString(pPara->pszTextFilename,gpszEntry_TextFilename);
	bRet &= WriteString(pPara->pszFontName, gpszEntry_FontName);	
	bRet &= WriteInt(pPara->lFontHeight,gpszEntry_FontHeight);
	bRet &= WriteInt(pPara->lLineSpacing,gpszEntry_LineSpacing);
	bRet &= WriteInt(pPara->lTimeLimit,gpszEntry_TimeLimit);

	return bRet;
}

void GetDefaultValues(PTEXTPARAMS pPara)
{
	lstrcpy(pPara->pszTextFilename, TEXT_FILENAME);
	lstrcpy(pPara->pszFontName, FONT_NAME);	
	pPara->lFontHeight = FONT_HEIGHT;
	pPara->lLineSpacing = LINE_SPACING;
	pPara->lTimeLimit = TIME_LIMIT;
}
