#include <windows.h>
#include <mmsystem.h>
#include <string.h>
#include <stdio.h>
#include "LogTable.h"
#include "AddUnicode.h"
////////////////////////////////
#define MAX_LINE 1024

LPCTSTR gpszNewLine = TEXT("\r\n");
LPCTSTR gpszSpace = TEXT("\t ");
LPCTSTR gpszFileExtension = TEXT(".TAB");
LPCTSTR gpszFirstLine = TEXT("page\t line\t word\t left\t top\t right\t bottom\t text");
TCHAR gpszLogTableFilename[MAX_LINE];

long gnPage = 1;
HMMIO ghFile = NULL;
SYSTEMTIME gSystemTime;

void InitialCall();

////////////////////////////////

void LogTableSetFile(char* pszFilename)
{
	TCHAR* cptr;

#ifdef UNICODE
    MultiByteToWideChar(
		CP_ACP, // code page 
		MB_PRECOMPOSED, // character-type options 
		pszFilename, // address of string to map 
		-1, // number of characters in string 
		gpszLogTableFilename, // address of wide-character buffer 
		MAX_LINE // size of buffer 
	);
#else
	strcpy(gpszLogTableFilename, pszFilename);
#endif

	if (cptr = strstr(gpszLogTableFilename, TEXT(".")))
	{
		*cptr = 0;
	}

	lstrcat(gpszLogTableFilename, gpszFileExtension);
}

void OpenLogTable()
{
	ghFile = mmioOpen(gpszLogTableFilename, NULL, MMIO_WRITE | MMIO_CREATE);
	InitialCall();
}

void CloseLogTable()
{
	if (ghFile)
	{
		mmioClose(ghFile, 0);
		ghFile = NULL;
	}
}

BOOL DeleteLogTable()
{
	if (gpszLogTableFilename[0])
	{
		CloseLogTable();
		ghFile = mmioOpen(gpszLogTableFilename, NULL, MMIO_DELETE);
		ghFile = NULL;
		return TRUE;
	}
	return FALSE;
}

void InitialCall()
{
	TCHAR pszText[MAX_LINE];
	TCHAR* pszDate = TEXT("Date: ");
	TCHAR* pszTime = TEXT(" Time: ");
	TCHAR pszBuffer[10];
	GetLocalTime(&gSystemTime);

	lstrcpy(pszText, gpszLogTableFilename);
	lstrcat(pszText, TEXT("  --- LogTable ---  "));
	
	lstrcat(pszText, pszDate);

	wsprintf(pszBuffer,TEXT("%.2d"), gSystemTime.wDay); 
	lstrcat(pszText, pszBuffer);
	lstrcat(pszText, TEXT("."));

	wsprintf(pszBuffer, TEXT("%.2d"), gSystemTime.wMonth);
	lstrcat(pszText, pszBuffer);
	lstrcat(pszText, TEXT("."));
		
	wsprintf(pszBuffer, TEXT("%d"), gSystemTime.wYear);
	lstrcat(pszText, pszBuffer);

	lstrcat(pszText, pszTime);

	wsprintf(pszBuffer, TEXT("%.2d"), gSystemTime.wHour);
	lstrcat(pszText, pszBuffer);
	lstrcat(pszText, TEXT(":"));

	wsprintf(pszBuffer, TEXT("%.2d"), gSystemTime.wMinute);
	lstrcat(pszText, pszBuffer);
	lstrcat(pszText, TEXT(":"));

	wsprintf(pszBuffer, TEXT("%.2d"), gSystemTime.wSecond);
	lstrcat(pszText, pszBuffer);

	lstrcat(pszText, gpszNewLine);
	lstrcat(pszText, gpszNewLine);
	
	lstrcat(pszText, gpszFirstLine);

	lstrcat(pszText, gpszNewLine);
	lstrcat(pszText, gpszNewLine);

	if (ghFile)
	{
		mmioWrite(ghFile, (char _huge*) pszText, lstrlen(pszText));
	}
}

void LogTableSetPage(long nPage)
{
	gnPage = nPage;
}

BOOL LogTable(PLOGTABLEPARA para)
{
	BOOL bRet;
	TCHAR pszTextBuffer[MAX_LINE];
	TCHAR pszBuffer[10];

	bRet = FALSE;

	if (ghFile)
	{
		bRet = TRUE;

		wsprintf(pszBuffer, TEXT("%d"), gnPage);
		lstrcpy(pszTextBuffer, pszBuffer);
		lstrcat(pszTextBuffer, gpszSpace);

		wsprintf(pszBuffer, TEXT("%d"), para->nLine);
		lstrcat(pszTextBuffer, pszBuffer);
		lstrcat(pszTextBuffer, gpszSpace);

		wsprintf(pszBuffer, TEXT("%d"), para->nWordNo);
		lstrcat(pszTextBuffer, pszBuffer);
		lstrcat(pszTextBuffer, gpszSpace);

		wsprintf(pszBuffer, TEXT("%d"), para->rectWord.left);
		lstrcat(pszTextBuffer, pszBuffer);
		lstrcat(pszTextBuffer, gpszSpace);

		wsprintf(pszBuffer, TEXT("%d"), para->rectWord.top);
		lstrcat(pszTextBuffer, pszBuffer);
		lstrcat(pszTextBuffer, gpszSpace);

		wsprintf(pszBuffer, TEXT("%d"), para->rectWord.right);
		lstrcat(pszTextBuffer, pszBuffer);
		lstrcat(pszTextBuffer, gpszSpace);

		wsprintf(pszBuffer, TEXT("%d"), para->rectWord.bottom);
		lstrcat(pszTextBuffer, pszBuffer);
		lstrcat(pszTextBuffer, gpszSpace);

		lstrcat(pszTextBuffer, para->pszWord);
			
		lstrcat(pszTextBuffer, gpszNewLine);

		if (ghFile)
		{
			if (mmioWrite(ghFile, (char _huge*) pszTextBuffer, lstrlen(pszTextBuffer))
				== -1)
			{
				bRet = FALSE;
			}
		}
	}
	return bRet;
}
