#ifndef GLOBAL_GC_REG
#define GLOBAL_GC_REG

// *** This defines global data for the gaze logging, the gaze triggering
// *** and the stimulus regions data as used in reading_trial and
// *** reading_stimulus ... modified extract from the gc toolkit example
// *** modifications 3/2001 by Eric Auer

                        // CONTROL REGION DEFINITION 
typedef struct {
		int triggered;	// is triggered
		long avgxsum;	// average position accumulators
		long avgysum;
		long dwell;	// total time in region
		RECT rsense;	// region for gaze
		RECT rdraw;	// rectangle for invert
		int cx, cy;	// center for drift correction
		char rword[100]; // *** added... sorry, no TCHAR here ;)
		} REGION;
		
long dwell_threshold = 700;	// msec of gaze in region required to trigger
		
#define NREGIONS  1000 		/* *** */
int used_regions = 0; 		/* *** */
// array of control regions 
REGION rgn[NREGIONS];

int last_region = -1;	  // region with gaze at last update
int current_region = -1;  // region currently accumulating gaze time

#endif
