/* *** lots of this is by Eric Auer 3/2001, but its inspired *** */
/* *** by LoadingATextFile.c from the eyetracker toolkit     *** */


#define TRIALS_MAX 100
#define gDefKeyword TEXT("define")
#define gDefKeywordLen 6
#define ScriptWidth 1024

#include <windows.h>
#include <stdio.h>
#include <ctype.h>		// *** for isgraph
#include <string.h>		// *** for strlen
#include "AddUnicode.h"
#include "reading_loadscript.h" // ***

LPTCH glpScriptText = NULL;
TRIALPARAMS TheTrials[TRIALS_MAX];
long glTrialCount;
long glTrialLen;


long CreateTrials(TCHAR* src, long len)
{
  TCHAR pszBuffer[ScriptWidth+1];
  TCHAR* src_end;
  TRIALPARAMS trialdefines[42];	// special use for pszTrialIdent!
				// but some values are unused (time, filename)
  long bComment;	// *** ok, b implies bool, but I like int better
  long bDefine;	// *** see above
  long lDefCount;	// *** number of defines used up so far
  long lWord;	// *** counting the words in the row
  long i;	// *** used as define index
// ***	long count = 0;
  glTrialCount = 0;
  lDefCount = 0;
  bComment = 0;
  lWord = 0;
  bDefine = 0;
  src_end = src + len; // *** hope this works

  while (src < src_end) // *** was count < len
  {
    sscanf(src, TEXT(" %1024s "), pszBuffer);
    // sscanf returns the no of % escapes that could be filled
    // *** whitespace in format string -> skip whitespace
    if (pszBuffer[0] == ';') || (pszBuffer[0] == '#'))
    { // if bComment goes 0->1 we could do something
      bComment = 1;
    }
    if (bComment == 0) lWord++; // found non-comment word
    if (bComment == 0)
    { // this is the fun part!
	if (lWord == 1)
	{
	  // if lWord is 1 - is the word "define" ?
	  // then inc lDefCount, check for < 42,
	  // set bDefine. ELSE look for the matching
	  // define, inc glTrialCount, check for < 100
	  if (lstrcmp(pszBuffer,gDefKeyword) == 0)
	  {
		bDefine = 1;	// go to "define mode"
		if (lDefCount > 41) return glTrialCount; // overflow!!!
	  }
	  else
	  {
		bDefine = 0;	// go to "trial mode", init trial.
		if (glTrialCount > 99) return 99; // overflow!!!
		TheTrials[glTrialCount].pszTrialIdent[0] = '\0';
		TheTrials[glTrialCount].lTimeLimit = -1;
		TheTrials[glTrialCount].pszTextFileName[0] = '\0';
		TheTrials[glTrialCount].lUsedButtons = -1;
		for (i=0; i<lDefCount; i++)
		{
			if (lstrcmp(pszBuffer,trialdefines[i].pszTrialIdent) == 0)
			{
				// use the matching define
				TheTrials[glTrialCount].bGazeActivate =
				trialdefines[i].bGazeActivate;
				TheTrials[glTrialCount].bLogStream =
				trialdefines[i].bLogStream;
				TheTrials[glTrialCount].bUsedButtons =
				trialdefines[i].bUsedButtons;
				strcpy(TheTrials[glTrialCount].pszButtonList,
				       trialdefines[i].pszButtonList);
			}
		}
		if (TheTrials[glTrialCount].lUsedButtons < 0)
			return glTrialCount; // failed to find matching define
	  }
	};
	if (lWord == 2)	// second is always the ident (both for trials and defines)
	{
		if (bDefine == 0)
		{
			strncpy(TheTrials[glTrialCount].pszTrialIdent,
			       pszBuffer,255);
		}
		else
		{
			strncpy(trialdefines[lDefCount].pszTrialIdent,
			       pszBuffer,255);
		}
	}
	if (lWord == 3)
	{
		if (bDefine == 0)	// if it is a trial...: time limit
		{
			sscanf(pszBuffer,TEXT(" %ld "),
                               TheTrials[glTrialCount].lTimeLimit);
			// atoi would be easier, maybe.
		}
		else			// if it is a define...: gaze activation
		{
			if ((pszBuffer[0] == 'n') || (pszBuffer[0] == 'N'))
			{
				trialdefines[lDefCount].bGazeActivate = FALSE;
			}
			else
			{
				trialdefines[lDefCount].bGazeActivate = TRUE;
			}
		}
	}
	if (lWord == 4)
	{
		if (bDefine == 0)	// if it is a trial...: filename.
		{
			strncpy(TheTrials[glTrialCount].pszTextFilename,
			       pszBuffer,255);
		}
		else			// if it is a define...: stream
		{
			if ((pszBuffer[0] == 'n') || (pszBuffer[0] == 'N'))
			{
				trialdefines[lDefCount].bLogStream = FALSE;
			}
			else
			{
				trialdefines[lDefCount].bLogStream = TRUE;
			}
			trialdefines[lDefCount].lUsedButtons = 0; // init this!
			trialdefines[lDefCount].pszButtonList[0] = '\0'; // int!
		}
	}
	if (lWord >= 5)	// the rest is optional. so far we had:
			// define class gaze stream (next: button(s))
			// class ident timeout filename (next: <unused>)
	if (bDefine == 1)	// ignore rest of the line if trial
	{
		// pszBuffer may be a char -> concat to list, count it
		// or a string -> expresses a special char -> as above
		// if unknown special char, return from func, maybe warn!!!
		i = 0:	// our new button
		if (strlen(pszBuffer) > 1)	// need to resolve?
		{
			// *** this could be done with much more style!
			// *** w32_exptsppt.h has 4 arrows, pgup/pgdn, esc, cr
			if (lstrcmp(pszBuffer,TEXT("left")) == 0)
			{
				i = CURS_LEFT;
			}
			if (lstrcmp(pszBuffer,TEXT("right")) == 0)
			{
				i = CURS_RIGHT;
			}
			if (lstrcmp(pszBuffer,TEXT("up")) == 0)
			{
				i = CURS_UP;
			}
			if (lstrcmp(pszBuffer,TEXT("down")) == 0)
			{
				i = CURS_DOWN;
			}
			if (lstrcmp(pszBuffer,TEXT("space")) == 0)
			{
				i = ' '; // char to int! (see toolkit->getkey)
			}
		}
		if ((strlen(pszBuffer) == 1) || (i != 0))
		{
			if (strlen(pszBuffer) == 1) i = pszBuffer[0]; // char to int!
			if (trialdefines[lDefCount].lUsedButtons > 250)
				return glTrialCount;	// add warning!?
			trialdefines[lDefCount].pszButtonList[
			trialdefines[lDefCount].lUsedButtons] = i;
			trialdefines[lDefCount].lUsedButtons++;
		}
		else	// buffer was empty or resolve failed
		{
			// ignore failure for now!!!
		}
	}
	} // end of fun part.
	while (!isgraph(*src)) src++;	// skip leading whitespace
					// dont confuse isprint/isgraph
	src += strlen(pszBuffer); 	// trailing whitespace is no
					// problem here
	if ((*src == '\r') || (*src == '\n'))
	{ 
		if (lWord) // -> this line was useful
		{
			if (bDefine)
			{
				lDefCount++;
			}
			else
			{
				glTrialCount++;
			}
		}
		lWord=0; bComment=0; bDefine=0;
		while ((*src == '\r') || (*src == '\n')) src++;
	}
    } // end of "no comment"
  }
  // count from 1..n (so 0 means failure)
  glTrialCount++;
  return glTrialCount;
}

BOOL LoadScript(TCHAR* pszFilename, long* plTrials)
{
	HANDLE hFile;
	BOOL bSucceeded;
	DWORD dwBytesRead;
	LPTCH lpTemp = NULL;

	hFile = CreateFile(pszFilename,
			GENERIC_READ,
			(DWORD) 0,
			NULL,
			OPEN_EXISTING, 
			FILE_ATTRIBUTE_NORMAL,
			(HANDLE) 0);
	if (hFile == INVALID_HANDLE_VALUE)
	{
		return FALSE;
	}
	// else
	glScriptLen = GetFileSize(hFile, NULL);
	lpTemp = (LPTCH) GlobalAlloc(0, glScriptLen);
	bSucceeded =  ReadFile(
		hFile,                // handle of file to read
		lpTemp,             // pointer to buffer that receives data
		glScriptLen,  // number of bytes to read
		&dwBytesRead, // pointer to number of bytes read
		NULL   // pointer to structure for data
	);
	CloseHandle(hFile);
	if (!bSucceeded)
	{
		GlobalFree((HGLOBAL) lpTemp);
		return FALSE;
	}
	// else
// ***	glpScriptText = (LPTCH) GlobalAlloc(0, glScriptLen);
	*plTrials = CreateTrials(lpTemp, NULL/* glpScriptText */, glScriptLen);
	GlobalFree((HGLOBAL) lpTemp);
	
	return TRUE;
}

void ReleaseScript()
{
// ***	GlobalFree((HGLOBAL) glpScriptText);
}

PTRIALPARAMS GetTrial(long trialno)
{
	if ( (trialno <= glTrialCount) && (trialno > 0) )
	{
		return &TheTrials[trialno-1];
	}
	else
	{
		return NULL;
	}
}
